/*
 * Charlieplexing sopelek
 *
 *   Sylwek
 *   19-12-2018
 *
 *   ATTINY13 9,6MHz
 *   fusy: 7A, FF
 */

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>

//*******************************************************************************
uint8_t pwm[12];		//liczniki PWM
volatile uint8_t lum[12];	//tablica jasnoci, PWM 16 poziomw (0-15) TU SI STERUJE JASNOCI
//----------------------
//tablica charlieplexing
//4sb-DDRB, 4mb-PORT
const uint8_t sel[] PROGMEM = {
    0b00110001,
    0b00110010,
    0b01100010,
    0b01100100,
    0b11000100,
    0b11001000,
    0b01010001,
    0b01010100,
    0b10100010,
    0b10101000,
    0b10010001,
    0b10011000
}; //0,1,2,3,4,5,6,7,8,9,10,11
#define SEL(x) pgm_read_byte(&sel[x])	//mae udogodnienie :)

volatile uint8_t timer;

//---------------------------------------------------------------------------------------------
void led_on(uint8_t nr)
{
  DDRB=(SEL(nr)>>4); //wycignicie 4-ech starszych bitw na pozycj modszych
  PORTB=(SEL(nr) & 0b00001111); //uwzgldnij tylko 4 modsze bity
}

#define led_off DDRB=0; PORTB=0;

//---------------------------------------------------------------------------------------------


//---------- efekt sopla -----------
int8_t i, x;

const uint8_t sopel[] PROGMEM = {15,8,5,4,3,2,1,0,0,0,0,0};	//wzorek sopla
#define SOP(x) pgm_read_byte(&sopel[x])

//----------------------------------

//*******************************************************************************
int main(void)
{
  //------------------------------------------
  //ustawienie przerwa
   TCCR0A |= (1<<WGM01); //CTC
 //  TCCR0B |= (1<<CS00); //Prescale 1
   TCCR0B |= (1<<CS01);  //Prescale 8
   TIMSK0 |= (1<<OCIE0A);//zezwolenie na przerwanie CompareMatch
//   OCR0A=119;            //10khz przy 9,6Mhz /8 (okres 100us)
   OCR0A=59;            //20khz przy 9,6Mhz /8 (okres 50us)
//   OCR0A=29;            //40khz przy 9,6Mhz /8 (okres 25us)
  //------------------------------------------
  sei();
  while(1)
    {
      if(!timer)
	{
	  timer=70;	//prdko efektu
	  for(i=11; i>0; i--) {lum[i] = lum[i-1];}
	  if(x < 12) lum[0] = SOP(x);
	  if(x++ == 30) x=0;	//odstp midzy sopelkami
	}
    }//END while
}// END main
//*******************************************************************************
//*******************************************************************************
ISR(TIM0_COMPA_vect)
{
  static uint8_t r, tp;
  if(tp++ == 20)
    {
      tp=0;
      if(timer) timer--;
    }
  //--------------------------------
  //cykliczne zapalanie kadej diody z uwzgldnieniem jej luminacji
  led_off;	//wyczenie diod
  if (lum[r] > pwm[r]) led_on(r);	//tu jest zarzdzanie jasnoci (PWM)
  if (pwm[r]++ > 15) pwm[r]=0;
  if(r++ > 11) r=0;
  //--------------------------------

}
//*******************************************************************************
//*******************************************************************************
